DEFINE VARIABLE attribute AS CHARACTER NO-UNDO FORMAT "x(30)" LABEL "Attribute".
DEFINE VARIABLE queryable AS LOGICAL NO-UNDO LABEL "Query".
DEFINE VARIABLE setable AS LOGICAL NO-UNDO LABEL "Set".
DEFINE VARIABLE setexp AS LOGICAL NO-UNDO LABEL "SetExp".
DEFINE VARIABLE temp-handle AS HANDLE NO-UNDO.
DEFINE VARIABLE resource AS CHARACTER NO-UNDO FORMAT "x(20)" LABEL "Resource".

DEFINE VARIABLE assigned AS LOGICAL NO-UNDO.

input from "can_qset_test1.ini" no-echo.
output to "can_qset_test1.log".

DEFINE FRAME f0 resource attribute setexp setable queryable WITH DOWN WIDTH 85.

function check-attribute returns logical (input h as handle):
   queryable = CAN-QUERY(h, attribute).
   setable   = CAN-SET(h, attribute).
   return true.
end.

REPEAT:

   update resource attribute setexp.

/* Currently not supported   
   if resource eq "browse" then
      CREATE browse temp-handle.
   
   if resource eq "call" then
      CREATE call temp-handle.
   
   if resource eq "dataset" then
      CREATE dataset temp-handle.
   
   if resource eq "data-source" then
      CREATE data-source temp-handle.
*/ 
   assigned = no.
   
   if resource eq "query" then do:
      CREATE query temp-handle.
      assigned = yes.
   end.
   
   if resource eq "sax-attributes" then do:
      CREATE sax-attributes temp-handle.
      assigned = yes.
   end.
   
   if resource eq "sax-reader" then do:
      CREATE sax-reader temp-handle.
      assigned = yes.
   end.
   
   if resource eq "sax-writer" then do:
      CREATE sax-writer temp-handle.
      assigned = yes.
   end.
   
   if resource eq "server" then do:
      CREATE server temp-handle.
      assigned = yes.
   end.
   
   if resource eq "server-socket" then do:
      CREATE server-socket temp-handle.
      assigned = yes.
   end.
   
   if resource eq "soap-header" then do:
      CREATE soap-header temp-handle.
      assigned = yes.
   end.
   
   if resource eq "soap-header-entryref" then do:
      CREATE soap-header-entryref temp-handle.
      assigned = yes.
   end.
   
   if resource eq "socket" then do:
      CREATE socket temp-handle.
      assigned = yes.
   end.

   if resource eq "temp-table" then do:
      CREATE temp-table temp-handle.
      assigned = yes.
   end.
   
   if resource eq "x-document" then do:
      CREATE x-document temp-handle.
      assigned = yes.
   end.
   
   if resource eq "x-noderef" then do:
      CREATE x-noderef temp-handle.
      assigned = yes.
   end.

   /* The widgets start here */   
   if resource eq "button" then do:
      CREATE button temp-handle.
      assigned = yes.
   end.
   
   if resource eq "combo-box" then do:
      CREATE combo-box temp-handle.
      assigned = yes.
   end.
   
   if resource eq "control-frame" then do:
      CREATE control-frame temp-handle.
      assigned = yes.
   end.
   
   if resource eq "dialog-box" then do:
      CREATE dialog-box temp-handle.
      assigned = yes.
   end.
   
   if resource eq "editor" then do:
      CREATE editor temp-handle.
      assigned = yes.
   end.
   
   if resource eq "fill-in" then do:
      CREATE fill-in temp-handle.
      assigned = yes.
   end.
   
   if resource eq "frame" then do:
      CREATE frame temp-handle.
      assigned = yes.
   end.
   
   if resource eq "image" then do:
      CREATE image temp-handle.
      assigned = yes.
   end.
   
   if resource eq "menu" then do:
      CREATE menu temp-handle.
      assigned = yes.
   end.
   
   if resource eq "menu-item" then do:
      CREATE menu-item temp-handle.
      assigned = yes.
   end.
   
   if resource eq "radio-set" then do:
      CREATE radio-set temp-handle.
      assigned = yes.
   end.
   
   if resource eq "rectangle" then do:
      CREATE rectangle temp-handle.
      assigned = yes.
   end.
   
   if resource eq "selection-list" then do:
      CREATE selection-list temp-handle.
      assigned = yes.
   end.
   
   if resource eq "slider" then do:
      CREATE slider temp-handle.
      assigned = yes.
   end.
   
   if resource eq "sub-menu" then do:
      CREATE sub-menu temp-handle.
      assigned = yes.
   end.
   
   if resource eq "text" then do:
      CREATE text temp-handle.
      assigned = yes.
   end.
   
   if resource eq "window" then do:
      CREATE window temp-handle.
      assigned = yes.
   end.
   
   if resource eq "file-info" then do:
      check-attribute(file-info).
      DISPLAY resource attribute setexp setable queryable WITH DOWN frame f0.
      resource = "". 
   end.
   
   if assigned then do:

      check-attribute(temp-handle).
      DISPLAY resource attribute setexp setable queryable WITH DOWN frame f0.
      resource = "". 
      
   end.
   
END.

output close.
input close.
